--secure digging wrappers
local function secureDig()
  while turtle.detect() do 
    turtle.dig() 
  end
end
local function secureDigUp()
  while turtle.detectUp() do 
    turtle.digUp() 
  end
end
local function secureDigDown()
  while turtle.detectDown() do 
    turtle.digDown() 
  end
end



--location returning move wrapper
--https://www.youtube.com/watch?v=bZe5J8SVCYQ
local function forward(x, y, z, rotation)
  if turtle.forward() then
    if rotation == 0 then
      z = z + 1
    elseif rotation == 1 then
      x = x - 1
    elseif rotation == 2 then
      z = z - 1
    else
      x = x + 1
    end
  end
  return x,y,z,rotation
end

local function back(x, y, z, rotation)
  if turtle.back() then
    if rotation == 0 then
      z = z - 1
    elseif rotation == 1 then
      x = x + 1
    elseif rotation == 2 then
      z = z + 1
    else
      x = x - 1
    end
  end
  return x,y,z,rotation
end

local function up(x, y, z, rotation)
  if turtle.up() then
    y = y + 1
  end
  return x,y,z,rotation
end

local function down(x, y, z, rotation)
  if turtle.down() then
    y = y - 1
  end
  return x,y,z,rotation
end

local function left()
  rotation = (rotation-1) % 4
  return x,y,z,rotation
end

local function right()
  rotation = (rotation+1) % 4
  return x,y,z,rotation
end



return
{
  secureDig=secureDig,
  secureDigUp=secureDigUp,
  secureDigDown=secureDigDown,
  forward=forward,
  back=back,
  up=up,
  down=down,
  left=left,
  right=right,
}